﻿package com.rubenbristian.medialove{

	import flash.display.Sprite;
	import flash.display.Loader;
	import flash.display.StageDisplayState;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.BlurFilter;
	import flash.utils.Dictionary;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.net.URLRequestMethod;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLVariables;
	import flash.net.SharedObject;
	import flash.ui.Mouse;
	import flash.xml.XMLDocument;
	import flash.system.Security;

	import com.greensock.TweenMax;

	public class MediaLove extends Sprite {

		private var mainXML:XML;
		private var countA:int;
		private var countB:int;
		private var loader:Loader = new Loader();

		public function MediaLove():void {

			Security.allowDomain("*");

			createBack();
			createPoll();

		}

		private function createPoll():void {

			var votesLoader:URLLoader = new URLLoader();
			votesLoader.addEventListener(Event.COMPLETE, parseVotes);
			votesLoader.load(new URLRequest("votes.xml"));

			optionA.btnLove.buttonMode=optionB.btnLove.buttonMode=true;
			optionA.btnLove.mouseChildren=optionB.btnLove.mouseChildren=true;

			optionA.btnLove.addEventListener(MouseEvent.ROLL_OVER, rollOverTint);
			optionB.btnLove.addEventListener(MouseEvent.ROLL_OVER, rollOverTint);
			optionA.btnLove.addEventListener(MouseEvent.ROLL_OUT, rollOutTint);
			optionB.btnLove.addEventListener(MouseEvent.ROLL_OUT, rollOutTint);
			optionA.btnLove.addEventListener(MouseEvent.CLICK, voteA);
			optionB.btnLove.addEventListener(MouseEvent.CLICK, voteB);

			optionA.btnTrailer.buttonMode=optionB.btnTrailer.buttonMode=true;
			optionA.btnTrailer.mouseChildren=optionB.btnTrailer.mouseChildren=false;

			optionA.btnTrailer.addEventListener(MouseEvent.ROLL_OVER, rollOverTint);
			optionB.btnTrailer.addEventListener(MouseEvent.ROLL_OVER, rollOverTint);
			optionA.btnTrailer.addEventListener(MouseEvent.ROLL_OUT, rollOutTint);
			optionB.btnTrailer.addEventListener(MouseEvent.ROLL_OUT, rollOutTint);
			optionA.btnTrailer.addEventListener(MouseEvent.CLICK, watchA);
			optionB.btnTrailer.addEventListener(MouseEvent.CLICK, watchB);


		}

		private var cookie:SharedObject=SharedObject.getLocal("unique");
			
		private function parseXML(event:Event):void {

			mainXML=new XML(event.target.data);

			if (cookie.data.pollid==String(mainXML.attribute('id'))) {
				showResults();
			}

			optionA.txtTitle.text=mainXML.children()[0].title;
			optionB.txtTitle.text=mainXML.children()[1].title;
			init();

		}

		private function parseVotes(event:Event):void {

			var votes:XML=new XML(event.target.data);
			countA=parseInt(votes.optionA);
			countB=parseInt(votes.optionB);

			var xmlLoader:URLLoader = new URLLoader();
			xmlLoader.addEventListener(Event.COMPLETE, parseXML);
			xmlLoader.load(new URLRequest("love.xml"));

		}

		private function init():void {

			optionA.mcEmpty.width=optionA.mcFull.width=optionB.mcEmpty.width=optionB.mcFull.width=0;

			TweenMax.to(mcHeader, .3, {alpha:1, y:mcHeader.y-20});
			TweenMax.to(optionA, .3, {alpha:1, y:optionA.y-20, delay:.2});
			TweenMax.to(mcVs, .2, {alpha:1, y:mcVs.y-20, delay:.3});
			TweenMax.to(optionB, .3, {alpha:1, y:optionB.y-20, delay:.4});

			TweenMax.to(mcPlayer, 0, {autoAlpha:0});
			stage.addEventListener(Event.RESIZE, checkResize);
			
			mcPlayer.btnClose.buttonMode = true;
			mcPlayer.btnClose.addEventListener(MouseEvent.ROLL_OVER, rollOverTint);
			mcPlayer.btnClose.addEventListener(MouseEvent.ROLL_OUT, rollOutTint);
			mcPlayer.btnClose.addEventListener(MouseEvent.CLICK, closeVideo);

		}

		private function rollOverTint(event:MouseEvent):void {
			TweenMax.to(event.target, .3, {tint:0xFF3265});
		}

		private function rollOutTint(event:MouseEvent):void {
			TweenMax.to(event.target, .3, {tint:0xFFFFFF});
		}

		private function voteA(event:MouseEvent):void {
			countA++;
			setCookie();
			showResults();
		}

		private function voteB(event:MouseEvent):void {
			countB++;
			setCookie();
			showResults();
		}

		private function showResults():void {

			TweenMax.to(optionA.btnTrailer, .2, {autoAlpha:0});
			TweenMax.to(optionA.btnLove, .2, {autoAlpha:0});
			TweenMax.to(optionB.btnTrailer, .2, {autoAlpha:0});
			TweenMax.to(optionB.btnLove, .2, {autoAlpha:0});

			TweenMax.to(optionA.mcEmpty, .3, {width:137, delay:.2});
			TweenMax.to(optionA.mcFull, .4, {width:Math.round(countA*137/(countA+countB)), delay:.4});

			TweenMax.to(optionB.mcEmpty, .3, {width:137, delay:.2});
			TweenMax.to(optionB.mcFull, .4, {width:Math.round(countB*137/(countA+countB)), delay:.4});

			optionA.txtPercent.text=countA;
			optionB.txtPercent.text=countB;

			TweenMax.from(optionA.txtPercent, .3, {alpha:0, delay:.7});
			TweenMax.from(optionB.txtPercent, .3, {alpha:0, delay:.7});

			updateVotes();

		}

		private function updateVotes():void {

			var newXML:String='<?xml version="1.0" encoding="utf-8"?>';
			newXML+='<votes>';
			newXML+='<optionA>'+countA+'</optionA>';
			newXML+='<optionB>'+countB+'</optionB>';
			newXML+='</votes>';

			var newVotes:URLRequest=new URLRequest("love.php");
			newVotes.method=URLRequestMethod.POST;
			var variables:URLVariables = new URLVariables();
			variables.newXML=newXML;
			newVotes.data=variables;

			var votesLoader:URLLoader=new URLLoader(newVotes);
			votesLoader.dataFormat=URLLoaderDataFormat.VARIABLES;
			votesLoader.load(newVotes);

		}

		private function setCookie():void {

			cookie.data.pollid=String(mainXML.attribute('id'));
			cookie.flush();
			
		}

		private function checkResize(event:Event):void {
			if (stage.displayState!=StageDisplayState.FULL_SCREEN) {
				optionA.visible=optionB.visible=mcVs.visible=true;
				mcPlayer.visible=false;
				Object(loader.content).destroy();
				mcPlayer.removeChildAt(2);
			}
		}
		
		private function closeVideo(event:MouseEvent):void{
			stage.displayState=StageDisplayState.NORMAL;
		}

		private function watchA(event:MouseEvent):void {
			startTrailer(mainXML.children()[0].src);
		}

		private function watchB(event:MouseEvent):void {
			startTrailer(mainXML.children()[1].src);
		}

		private function startTrailer(id:String):void {
			optionA.visible=optionB.visible=mcVs.visible=false;
			stage.displayState=StageDisplayState.FULL_SCREEN;
			loader.contentLoaderInfo.addEventListener(Event.INIT, onLoaderInit);
			loader.load(new URLRequest("http://www.youtube.com/v/"+id+"?version=3"));
			stage.addEventListener(Event.ENTER_FRAME, fixMouse);
		}

		private function onLoaderInit(event:Event):void {
			mcPlayer.addChild(loader);
			loader.content.addEventListener("onReady", onPlayerReady);
		}

		private function onPlayerReady(event:Event):void {
			Object(loader.content).setSize(920, 518);
			Object(loader.content).playVideo();
			TweenMax.to(mcPlayer, .5, {autoAlpha:1});
		}

		private function fixMouse(event:Event):void {
			Mouse.show();
		}
	
		private function createBack():void {

			var sizeW:int=200;
			var sizeH:int=300;
			var circles:int=20;
			var circlesDict:Dictionary = new Dictionary();

			for (var i:int = 0; i<circles; i++) {

				var red:int=Math.random()*255;
				var green:int=Math.random()*255;
				var blue:int=Math.random()*255;

				var circle:Sprite = new Sprite();
				circle.graphics.beginFill(red << 16 | green << 8 | blue);
				circle.graphics.drawCircle(0,0,Math.round(Math.random()*20+40));
				circle.graphics.endFill();
				circle.blendMode="add";
				circle.filters=[new BlurFilter(100,100,2)];

				circle.x=Math.random()*sizeW;
				circle.y=Math.random()*sizeH;

				var obj:Object = new Object();
				obj.xspeed=Math.round(Math.random()-1);
				if (obj.xspeed==0) {
					obj.xspeed+=1;
				}
				obj.yspeed=Math.round(Math.random()-1);
				if (obj.yspeed==0) {
					obj.yspeed+=1;
				}

				circlesDict[circle]=obj;

				circle.addEventListener(Event.ENTER_FRAME, moveCircle);

				mcBack.addChild(circle);

			}

			function moveCircle(event:Event):void {
				event.target.x+=circlesDict[event.target].xspeed;
				event.target.y+=circlesDict[event.target].yspeed;
				if (event.target.x<0||event.target.x>sizeW) {
					circlesDict[event.target].xspeed*=-1;
				}
				if (event.target.y<0||event.target.y>sizeH) {
					circlesDict[event.target].yspeed*=-1;
				}
			}

		}

	}

}